/*
	========================================================
						Tardis  v1.0
	========================================================
	(c) 2005 by Lutz Schubert
	thanks to Uwe for helping me render the Tardis :)
	
	"Doctor Who" and the "Tardis" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Tardis.kon for version history
*/
var swproc = 0;
var swirlduration = 10;
var tunnelwidth = imgTunnel.width;
var tunnelvoffset = imgTunnel.vOffset;

print("Back To Tunnel");

	// Blend Out
	var dematduration=72;
	var proc = 100;
	imgTardisMaterialised.opacity = 255;
	var dematerializeTardis=new CustomAnimation(100,dematerialize);
	animator.start(dematerializeTardis);

	if (preferences.sound.value==1)
	{
		play("Sounds/Dematerialise.mp3");
	}
	
	// Light up tunnel

//	wndMaterialised.visible = false;

		// TODO: NO MOUSE REACTION DURING DeMATERIALISATION
		function dematerialize()
		{
			if (proc<=dematduration)
			{
				imgTardisMaterialised.opacity = proc*254/dematduration;
				imgTardisMaterialised.opacity += (dematduration-proc) * (Math.cos(4* 2*3.1416*proc/dematduration)-1);	//(matduration/proc)
			}

			if (((100-proc) % 19) == 0)
			{
				var materializeLight=new CustomAnimation(100,matlight);
				light2counter=0;
				animator.start(materializeLight);
			}

			proc--;
			if (proc <= 0)
			{
				//wndMaterialised.visible = false; //too early -> breaks off light
				// START TUNNEL
				openTunnel();
				return false;
			}
			return true;
		}

		function openTunnel()
		{
			wndTunnel.visible = true;
			print("opening Tunnel");
			
			if (preferences.visibility.value==1)
			{
				// make the tunnel visible
				imgTunnel.hslAdjustment="0,0,0";
				var backgroundSwirlup = new CustomAnimation( 100, swirlup );
				imgTunnel.opacity = 255;
				swproc = swirlduration;
				tunnelvoffset = imgTunnel.vOffset;
				tunnelAnimation.pause = false;
				imgTunnel.opacity=255;
				wndTunnel.height=0;
				
	// TODO: tardis as separate window?
	// this way it would be possible to make the tardis larger than the background
				imgTardisBody.opacity = 255;
				imgTardisBody.hslAdjustment = "0,0,0";
				tardisRotate.pause = false;
				// at the same time: bring up Tardis (no light, just rotate and enlarge)

				//animator.runUntilDone(backgroundSwirlup);	//alternatively: thus the steps could be performed sequentially here
				animator.start(backgroundSwirlup);	// thus allowing for "normal" background animation
			}
		}

		// open the background animation, like a horizontal window
		function swirlup()
		{
			wndTunnel.height = (swirlduration-swproc)*(300/swirlduration);
			wndTunnel.vOffset = tunnelvoffset + 150 - (swirlduration-swproc)*(150/swirlduration);
			imgTunnel.vOffset = (swirlduration-swproc)*(150/swirlduration);

			imgTardisBody.width = (swirlduration-swproc)*(150/swirlduration);;
			imgTardisBody.height = (swirlduration-swproc)*(180/swirlduration);;
			imgTardisBody.hOffset = 150 + 75 - imgTardisBody.width/2;
			imgTardisBody.vOffset = 180 - 90 + (swirlduration-swproc)*(150/swirlduration) - imgTardisBody.height/2;
			
			swproc--;
			
			if (swproc<0)
			{
				blinkingLight.pause = false;
				wndMaterialised.visible = false;	// by now we may hide the tardis-window
				return false;
			}
			
			return true;
		}
