/*
	========================================================
						Tardis  v1.0
	========================================================
	(c) 2005 by Lutz Schubert
	thanks to Uwe for helping me render the Tardis :)
	
	"Doctor Who" and the "Tardis" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Tardis.kon for version history
*/
var proc=0;
var matduration=54;	// n*6

		//print( system.event.screenX+", "+system.event.screenY);
		var store = Number(preferences.lightfreq.value);
		tunnelAnimation.pause = true;
		blinkingLight.pause = true;
		lightAnimation.kill();
		
		var blend_lig = swirl_lig;
		var blend_sat = swirl_sat;
		var tardis_lig = 0;
		var tardis_sat = 0;

			imgLightBehind.opacity = 0;
			imgLightBlend.opacity = 0;
			imgLightRing.opacity = 0;
			imgLightBehind.hOffset = 125;
			imgLightBehind.vOffset = 125;
			imgLightBehind.width  = 200;
			imgLightBehind.height = 200;
			var steps = 3;

		// blending the tunnel away
		imgLightBehind.hOffset = 151;
		imgLightBehind.vOffset = 150;
		// 1
		var leaveTunnel=new CustomAnimation(50,blend);
		animator.runUntilDone(leaveTunnel);
		
		// 2
		blinkingLight.pause = true;
		tardisRotate.pause = true;
		imgTardisBody.opacity = 0;
		imgTunnel.opacity = 0;
		imgLightBehind.opacity = 0;
		imgLightRing.opacity = 0;
		imgLightBlend.opacity = 0;
		var closeTunnel=new CustomAnimation(50,disappear);
		animator.runUntilDone(closeTunnel);
		imgLightBehind.hOffset = 151;
		imgLightBehind.vOffset = 82;
		
		// hide the tunnel window
		// and make the tardis window visible
		// make sure all animations of the hidden window are stopped
		wndTunnel.visible = false;
		//tunnelAnimation.kill();
		//tardisRotate.kill();
		//blinkingLight.kill();
		
		imgTardisMaterialised.opacity = 0;
		wndMaterialised.visible = true;
		var materializeTardis=new CustomAnimation(100,materialize);
		animator.start(materializeTardis);
		
		if (preferences.sound.value==1)
		{
			play("Sounds/Materialise.mp3");
		}
		
		// Blending the tunnel
		function blend()
		{
			blend_lig += (100-swirl_lig)/steps; blend_sat+=(180-swirl_sat)/steps;
			tardis_lig+= 100/steps; tardis_sat+= 180/steps;
			imgTunnel.hslAdjustment = "" + swirl_hue + "," + blend_sat + "," + blend_lig;
			//Tardis.opacity -= 255/steps;
			imgTardisBody.hslAdjustment = "" + 0 + "," + tardis_sat + "," + tardis_lig;
			//TardisMain.opacity -= 255/steps;
			imgLightBehind.hslAdjustment = "" + 0 + "," + tardis_sat + "," + tardis_lig;
			imgLightBehind.opacity += 255/steps;
			imgLightBehind.width += 250/steps
			imgLightBehind.height = imgLightBehind.width;
			imgLightBehind.hRegistrationPoint = imgLightBehind.width/2;
			imgLightBehind.vRegistrationPoint = imgLightBehind.height/2;
			if ( tardis_lig >= 100 ) 
			{ 
				return false;	//finished
			}
			return true;
		}
		
		// make the tunnel disappear
		function disappear()
		{
			imgLightBehind.width -= 250/steps
			imgLightBehind.height = imgLightBehind.width;
			imgLightBehind.hRegistrationPoint = imgLightBehind.width/2;
			imgLightBehind.vRegistrationPoint = imgLightBehind.height/2;
			imgLightBehind.opacity -= 255/steps;
			if (imgLightBehind.opacity <= 0)
			{
				return false;
			}
			return true;
		}
		
		// USE EASEOUT?
		// TODO: NO MOUSE REACTION DURING MATERIALISATION
		function materialize()
		{
			proc++;
			imgTardisMaterialised.opacity = proc*254/matduration;
			imgTardisMaterialised.opacity += 50 * (Math.cos(3* 2*3.1416*proc/matduration)-1);	//(matduration/proc)

			if (( proc % (matduration/3)) == matduration/6)
			{
				var materializeLight=new CustomAnimation(100,matlight);
				light2counter=0;
				animator.start(materializeLight);
			}

			if (proc == matduration)
			{
				return false;
			}
			return true;
		}
