/*
	========================================================
						Tardis  v1.0
	========================================================
	(c) 2005 by Lutz Schubert
	thanks to Uwe for helping me render the Tardis :)
	
	"Doctor Who" and the "Tardis" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Tardis.kon for version history
*/

include("Functions.js");

// WINDOW 1
// initialise main values (static)
//------------------------------------
// rotating tardis
var tardis_imgs = 9;		// amount of animation images
var tardis_curimg = 1;		// current image

// background "swirl" (tunnel)
var swirl_hue = 0;
var swirl_hued = 5;
var swirl_sat = 0;
var swirl_satd = 5;
var swirl_lig = 0;
var swirl_ligd = 5;
		
//Light Data
var light_max  = 120;			// maximal size
var light2_max  = 130;			// maximal size

var hind_max   = 50;
var hind2_max   = 60;
				
var blend_max   = 160*3/4;
var blend2_max   = 140;

// initiate the animations
//----------------------------
// ANIMATION 1: Background "tunnelAnimation"
// swirl timer
var tunnelAnimation = new CustomAnimation( 1000, swirl );
animator.start( tunnelAnimation );	//??? tunnelAnimation.start();  STARTS AUTOMATICALLY WHEN JAVASCRIPT ENDS

// ANIMATION 2: Rotate Tardis		
// rotate tardis timer
var tardisRotate = new CustomAnimation( 100, rotate );
animator.start( tardisRotate );

// ANIMATION 3: Blinking Headlight
// light timer
var blinkingLight = new CustomAnimation( 1000, blink );
animator.start( blinkingLight );

// START IT ALL
init();
wndTunnel.visible=true;
